Version 2.7.0:
RC1:
Features updates
- [Font Converter]
  + Filter out Combining character and Spacing Modifier Letters
  + Increase the font size limitation in the font conversion utility
  + Speed up the font conversion process for ASTC and L1->L8 extended format
  + Preview font can be turned off
  + Add a checkbox to Select All/Deselect All in the Select Range dialog
  + Add info button for a font size limit
- [Flash Utility] Support updating the designated flash region
- [Image Converter] DXT1 gets padded to black
- [Disassembler] Identify and skip data appended for cmd_memwrite
  
Version 2.6.1:
Beta:
Features updates
- [Custom Touch] Adjust the compiled custom touch firmware to make it patchable
- [Video Converter] Video information text does not clear once the new session starts #438
- [UI] Replace icons in the [Convert] button for clear meaning
- [Session] Add recent file paths 
- [Font Converter] Speed up the font conversion process for ASTC extended format

Limitations
- Drawing preview image for converted characters makes the whole conversion double in time.
So, the drawing preview for Extended ASTC is disabled until finding out the proper way.

Alpha
Features updates
- [Font Converter]
   - Reduce the glyph file size
   - Open generated folder instead of Output folder
   - Use escape character \u in generated source code
   - Add "All" option in the extension mode
   - Unify the preview image of both mode
- [Custom Touch] Update JTC to version 1.4.0
- [Disassembler] Add the output file name in the Log window
- [Image Converter] Add the usage of options '-x' and '-g'
- Update "libMPSSE" which removes the Sleep in the API SPI_ToggleCS(), to improve performance dramatically

Version 2.6.0:
RC2:
Resolved issues
- [Animation Converter] The convert button is clickable even when the output path is empty
- [Video Converter] Strip off the audio stream if "Keep Audio Stream" is unchecked
- [PNG/JPEG Validator]
   - RAM_G usage is round up to an integer
   - remove the "Cancel" button in the "Generate the optimized file" information popup
   - disable the "Open Output Location" button if "Generate the optimized file" is unchecked

Limitations
- [Font Converter] Characters are not alignment vertical in a button widget

RC1
Features updates
- [Font Converter] Remove empty block in the font image preview
- [SampleApp][Video Converter] Remove CMD_SWAP in generated code 
- [Image Validator]
   - PNG: Convert color type Greyscale+Alpha to Truecolour+Alpha
   - Resize an image if its size exceeds the graphics ram's size

Resolved issues
- [Image Converter] Layout is broken when displaying on a small screen

Beta1
Features updates
- [Font Converter] Add font encoding
- [Video Converter]
   - User can select to keep or remove an audio stream
   - Bitrate options are grouped

Resolved issues
- Prevent error code printing to console
- [Animation Converter] Fixed bitmap type of animation frame
- [Font Converter]
     - Modify the generated C-source for both Legacy and Extended

Alpha1
Features updates
- Add a button to open a terminal window
- Add a button to show the latest command line which has executed
- Rename font and animation tools
- Update the SampleApp folder
- Move "astcenc.exe" to sub-folder $EAB Install/tools
- Change application style from Fusion to WindowVista
- [Animation Converter] Modify the introduction and add the Hint button
- [Disassembler] Modify the introduction and change the tooltip in the input files area
- [Assets For Test] Rename subfolders following their related tools
- [Video Converter] Add advanced mode to control the output bitrate
- [Font Converter]
     - Modify the introduction
     - Add explanation for Font Block Info
     - Add an index to the previewed image
     - Improve filter characters in Legacy mode
- Improve the User guide:
     - Describe the naming convention of the EAB output filename
     - Explain the folder structure of SampleApp

Resolved issues
- [Video Converter] Fixed an issue that converted video cannot play due to inverse order of video and audio stream 
- [Font Converter]
     - Some characters are cut off
     - Selected ranges are reset after changing font size

Version 2.5.1
RC2
Features updates
-  [Bin2C] Update notation in command-line to unify with UI
-  [Image Converter] Add button Hint for multi-cell bitmap
-  [Animation] Add button hint and a validator to force address of animation must be dividable by 64
-  [Generate Font] Add explanation for Font Block Info
-  [Image Validator] When the input file is PNG targeting FT0X chip, EAB shows the more accurate hint 

Resolved issues
-  [Flash Utilities][Generate Flash Image] Fixed the Sub Type value of PALETTED565, PALETTED4444 & PALETTED8 

RC1
Features Upadate
-  [Session][Video Converter] Both width and height of video size are reset to 840x480 since session start
-  [Assets For Test] "Flash Image for Test" rename to "Flash Utility Test" for consistence 
-  [Disassembler] Add Endianness hint in the UI
-  [Image Converter] Add data padding function for ASTC based multi-cell bitmap
-  [Font Converter] Replace the number of assigned glyphs with total glyphs
-  [Flash Image Generator] Add the information on how to add animation asset
-  [Custom Touch Compiler] Update the touch compiler to the latest version
-  [User Guide] Add more details on EDF blocks

Resolved issues
-  [Flash Image Generator] subType in EDF block does not fit its definition

Version 2.5.0
RC1:
Feature updates
- Modify the usage of the Font Converter tool

Resolved issues
- [Flash Programming] Addressed issue [Read] button is enabled after one of "program flash" actions is executed
- [Disassembler][CMD_SETBITMAP] Fixed issue change the last two padding bytes to non-zero values will affect the output file

Beta1:
Feature updates
- [PNG/JPEG Validator] Add RAM_G usage to the log area
- [Video Convert] Suggest users increase bitrate/buffer if they cause underflow
- [Image Validator] Add RAM_G usage to log message
- [Flashing Programming] Utilize the stable version of EveHal 

Resolved issues
- [Bin2C] Addressed an issue when converting a binary file with hexadecimal notation
- [PNG/JPEG Validator] Fixed error of lacking runtime dll when validating using command line

Alpha1:
Feature updates
- Improve Font converter
  + Enable users to select multiple ranges
  + Combine "Printable ASCII" into Range selection
- Improve Video converter
  + Add dynamic label for Video Quality
  + Add three spinbox for the max bitrate, average bitrate, and video buffer size
  + Decode video to JPG files, optimize them by the tool "jpegtran", then encode to the video again
- Improve Disassembler
  + Change the tool name from Decode to Disassembler
  + Continue to disassemble even detecting invalid command
  + Add CMD_SETBITMAP
- [Audio Converter] When the option "add metadata" is checked
  + Disclose that output format will be ".mov"
  + Show warning of not suitable for Eve playback
- Improve Image validator
  + Make output folder disable if user don't check "Optimize before validation" because validation does not generate new
  + Add bitmap format of loaded image in log area
  + Calculate the RAM_G usage based on the loaded bitmap format and width x height
- Improve UI
  + Add "Copy Log" button
  + Change content margin of each utility tab
- [Session] User can input folder to save session file
- [Bin2C] Improve the format of the generated C array

Resolved issues
- [Flash Programming][MPSSE] Addressed issue "Detect" and "Program" do not work if SPI clock greater than 15 MHz
- [Image Validator] Fixed error happened when EAB validate a PNG image that has an invalid checksum

Version 2.4.1
RC1:
Resolved issues
- Use the "audioop" python module to convert the audio asset if the target format is IMA ADPCM

Version 2.4.0
RC2:
Feature updates
- [Font Converter] Limit input character
- [Eve Decode] Limit input file size up to 5 MBytes
- [Image Validator] Remove a bak file while using the command line

Resolved issues
- Valid Unicode range is added twice
- Cannot convert Symbol font in Extension format
- [Image Converter] SampleApp is not generated
- [Bin2C] The last line is in hex while the format is set as "decimal" 
- Generate flash fail if an asset is an ASTC
- [Asset Compressor] Remove option "-c" to prevent confusing
- [Image Converter] Could not convert into DXT1 format

RC1:
Feature updates
- Improve "eab_tools.exe": set output encoding 'utf-8', generate sample source code
- Remove command line mode from "Eve Asset Build.exe"
- Provide clock frequency options when FT4222 and MPSSE are used to program flash 
- Integrate Eve Decoder into EAB
- Make Font Block Info more readable
- List out the valid character range based on the input font file
- Add "Symbol" and "Printable ASCII" into [Extended Format] tab
- Remove *.bmp input file in PNG/JPEG validator
- PNG/JPEG validator improvement: specify Eve chip, optimize image before validating
- The RAM_G/FLASH address can be specified for animation asset
- User does not need to specify the compiler path
- Add pseudo code on how to use the custom firmware in the readme tab
- Improve audio utility: user can select to write file header or not
- Add more description about EDF block in User Guide
- Modify Focal Tech sample code of custom touch firmware compiler
- Remove video codec in Video Converter

Resolved issues
- Fixed converting font by installing appropriate ASTC encoder based on local CPU specification
- Fixed the address field for font data only allows for 5 digits
- Removed the option "Full Unicode" because of not useful and spend much time

Version 2.3.0:
RC3:
Resolved issues
- Fixed the failure of generating flash image if the animation object is added as an asset
- Fixed convert font fail if code point mode is 'Ordinal'

RC2:
Feature updates
- Insert EDF Block information in edf file and map file
- Reduce step of programing flash through Pico by automatically copying file "eve_flash_pico.uf2"
- Remove argument "--deploy" of tool uf2conv4eve.exe

RC1:
Feature updates
- User can program Eve-flash through Raspberry Pi Pico
- Add feature to convert Eve flash image file into UF2 file
- Export the converted characters after font conversion is done
- User can input a subset of characters to convert
- Add Verify function in flash programming utility
- Generate a binary form of flash image description file and store them after blob driver
- Add quality control option in video conversion utility
- Add hint to file browser button and folder browser button
- Correct legacy font-kerning
- Refuse to convert font if detect UCS-2 Byte Order Mark

Version 2.2.0:
RC2:
Feature updates
- Improve flash programming utility to work with 128 Mbytes flash chip
- Improve font utility:
  + Report only valid characters
  + Statisticize the number of characters in each Unicode range

RC1:
Feature updates
-   Upgrade to astcenc.exe v2.0 for faster encoding
-   Adjust the compiled custom touch firmware to make it patchable 
-   Add option for FT80x chip in Font Converter
-   Change generated function name for Legacy Font Converter
-   Add option to optimize JPEG file by using "jpegtran"
-   Adjust font metrics output

Version 2.1.0:
RC2:
Resolved issues
-   Fixed font conversion fail in "Extended Format"
-   Fixed the input file path of 'Characters To Be Converted' change unexpectedly 

RC1:
Feature updates
-   Add new tool Bin2C to convert binary file to C array
-   Update SampleApp under folder "Assets For Test"
-   Improve sample code generation in EAB
-   Upgrade to Python 3.8.5 64bits

Resolved issues
-   Fixed conversion fail if output folder is C drive

Version 2.0.0:
Feature updates
-   Add an option to escape line break in font conversion utility
-   Support the animation object in RAM_G (for BT817/8 only)
-   Add a utility for custom touch firmware support (for BT817/8 only)
-   Add bitmap format options in the Legacy format
-   Generate the preview PNG for extended format in font conversion utility
-   Update flash blob to the latest version to support BT817/8
-   Add one more option to program the flash
-   Migrate the application EAB as well as the background utilities to x64       
-   Improve image converter
-   Add two flash images to the "Assets for Test" folder at the installation path
-   Make programming module and EVE chip appear at programming tab 
    
Resolved issues
-   Addressed an issue that caused the degree symbol is not converted correctly
-   Fixed font conversion for font size is 240

v1.6.0:
   - Fix bugs:
      + flash detection fails but program succeeds
   - Improve the session functionality in EAB
   - Add the keyboard shortcut for changing the order in the flash image generator
   - Add shortcut key for deleting an item in the list widget
   - Add one "Clear" button for the log panel
   - Add one warning window to prompt the user for "Data Alignment" of EAB
   - Add a question mark to explain the hardware configuration of the flash programmer
   - Show glyph information in a different place

V1.5.0:
   - Fix bugs:
      + Some characters disappears from glyph if the code point mode is "utf-8"
      + Typo on code point mode drop-down box of font conversion utility
   - Add alignment option in flash image generation utility
   - Add a question mark to give the hint for code point mode of font conversion utility
   - Force 64-byte alignment for Flash address of Glyph file
   - Unknown FreeType error when converting the symbol font file
   - Provide more information while previewing the input font file
   - Provide more information on the result panel of font conversion utility
   - Add BMP file support in Image conversion and Animation conversion
   - Disable compression for a LUT file of the paletted format
   - Add more information on compression mode in the image conversion utility
   - Add the support of compression output in PNG2DXT1
   - Improve the flash utility in EAB
   - Improve the sample code for the flash utility
   - Add some description about re-ordering assets in the flash image generator
   - Add more information for the "compressed" option of image conversion utility
   - Improvement on result window of image conversion utility: File size and full extension name
   - Add a BMP file under the 'assets for test' folder of the installation path
   - Add a section in the user guide to list down the flash programmer modules

V1.4.0:
   - Fix bugs:
      + The UTF-8 code point 0xF09FA183 (i.e. 0x1F843 for unicode) cannot be displayed
      + The glyph file is not compressed when the code point is in UTF-8
      + eab_tools.exe will not run on a fresh 64-bit Win10 machine
      + Image conversion fail if current output folder does not exist
   - Add the "Verify" function in the flash utility
   - Recognize UTF8-BOM and remove it before converting
   - Speed up generating font when code point mode is UTF-8
   - Replace 'numpy' by 'tinynumpy' to reduce distribution package size

V1.3.0:
   - Fix bugs:
      + ProgFlash.exe is still running after EAB closed
      + Updating flash does not work with 512Mb chip
      + Erasing flash does not work with 512Mb chip
      + Generate flash image cannot work if the total size of assets are too big
   - Adjust the sequence of assets in the flash image generation utility
   - Warning user about flash content will be damaged once detect
   - Warn the users if the bitmap data is more than 1 M bytes
   - Deflate and combine multiple files into one file
   - Add "Dithering" check box in Image Converter

V1.2.0:
   - Fix bugs:
      + some icons of flash utility are invisible if the EAB window is adjusted till the smallest size
   - Flash Utilities:
      + Add a utility to detect the flash information
      + Add a new tab in flash utility to show the sample code of programming flash
      + Improve Flash UI
   - Animation:
      + Limit "Playback FPS" from 1 to 100
      + Change "Frame Ouput" to "Playback FPS"
   - Add deflate (compression) support to compress the asset
   - Handle '\x0A' in Font Conversion, Legacy format
   - Add a dialogue into the installation process of EAB to show the release note

V1.1.0:
   - Fix Bugs:
      + Check to generate C source file of Font Conversion
      + The generated code for Paletted8 format in the image conversion utility is not working as expected.
      + Incorrect generated C code for non-ASTC image conversion
      + Image Converter fails with two specific images
      + "NewBlob" function cannot be enabled after the flash bin file is selected
      + Failure to write to the Flash through EAB 1.0
      + The default unified blob is missing from Generate Flash Image utility's input editor box.
   - Add version number and building time at EAB title bar
   - Animation Conversion Improvement:
      + Animation utility UI improvement: user can choose Tile Width, Tile Height, or disabled Tile.
      + Improvement on animation conversion utility: add detailed information of generated animation
      + Animation previewing does not playback as expected order
      + Provide flash usage and display list usage for each frame in the animation utility
      + Update animation conversion Python script to accept Tile size from 1 to 6
   - Flash Utilities improvement:
      + Give out the error code when flash fails to enter into full speed mode
      + Check the data integrity of flash image files before updating/writing to flash
      + Add introduction to flash utility to align with other utility
      + Pop up a warning window to warn the user when erasing the flash
      + Display flash status code when it fails to program
      + Remove "Write" button in Program Flash
      + Add tooltips to the buttons in programming flash
      + Make Flash Programming Utility more precise
      + "Install Blob" button is hidden by default
      + A typo in the flash utility: change "Existing" to "Exiting"

V1.0.0:
   - Fix Bugs:
      + Image preview and Image selected do not match each other 
   - Check signature when open session file
   - Tweak generated C source file

V0.6.0:
   - Fix Bugs:
      + L4 and L1 formats are not converted correctly
      + RGB332 and RGB565 are not converted correctly
      + Ensure font in flash 64 bytes aligned
      + Glyph file is arbitrary due to using Python unordered set 
   - Minimize the size of the command-line utility to improve the executing speed
   - Support L1/L2/L4/L8 format in extended format tab of font conversion utility
   - Update UI of font conversion utility
   - Image Converter generated C file has an invalid function name

V0.4.2:
   - Fix Bugs.

V0.4.1:
   - Update Documentation.
   - Fix Bugs.

V0.4.0:
   - Set default compression speed to thorough.
   - Improve start time and font converting time.
   - Optimize the JPEG file with the jpegTrans tool.
   - Support select items to generate flash from multiple directories and adjust the order of items.
   - Fix Bugs.

V0.3.1:
   - Update new dlls for Qt5.11.1 and msvc2017.
   - Fix bugs.

V0.3.0:
   - Add console mode.
   - Fix bugs.

V0.2.1:
   - Update ft8xxemu.dll to compatible with Verify.exe
   - #14: display failed for incompatible png file.

V0.2.0:
   - Fix #12: sample code for paletted8 will fail when a picture is bigger than 511x511

V0.1.4:
   - Make UI resizable.

V0.1.3:
   - Support MPSSE Program Module.    

V0.1.2:
   - Change Audio Converter supported format from 16 bits PCM to 3 formats that EVE supports.
   - Generate C sample code for Audio and Video converter.
   - Add SampleApp project in Asset for Test.
   - Add a link to UserGuide in the Info tab.
   - Update latest blob file V4.
